package cn.com.tenlion.systembase.service.homicidevictim;

import cn.com.tenlion.systembase.pojo.bos.homicidevictim.HomicideVictimBO;
import cn.com.tenlion.systembase.pojo.dtos.homicidevictim.HomicideVictimDTO;
import cn.com.tenlion.systembase.pojo.pos.homicidevictim.HomicideVictimPO;
import cn.com.tenlion.systembase.pojo.vos.homicidevictim.HomicideVictimVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IHomicideVictimService
 * @Description: 命案受害人
 * @Author: CodeFactory
 * @Date: 2021-10-19 11:24:35
 * @Version: 3.0
 **/
public interface IHomicideVictimService {

    /**
     * 新增命案受害人
     *
     * @param homicideVictimVO
     * @return
     */
    void save(HomicideVictimVO homicideVictimVO);

    /**
     * 新增命案受害人
     *
     * @param token
     * @param homicideVictimVO
     * @return
     */
    void save(String token, HomicideVictimVO homicideVictimVO);

    /**
     * 新增命案受害人
     *
     * @param homicideVictimVO
     * @return homicideVictimId
     */
    String saveReturnId(HomicideVictimVO homicideVictimVO);

    /**
     * 新增命案受害人
     *
     * @param token
     * @param homicideVictimVO
     * @return homicideVictimId
     */
    String saveReturnId(String token, HomicideVictimVO homicideVictimVO);

    /**
     * 删除命案受害人
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除命案受害人
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除命案受害人（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改命案受害人
     *
     * @param homicideVictimId
     * @param homicideVictimVO
     * @return
     */
    void update(String homicideVictimId, HomicideVictimVO homicideVictimVO);

    /**
     * 修改命案受害人
     *
     * @param token
     * @param homicideVictimId
     * @param homicideVictimVO
     * @return
     */
    void update(String token, String homicideVictimId, HomicideVictimVO homicideVictimVO);

    /**
     * 命案受害人详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideVictimDTO get(Map<String, Object> params);

    /**
     * 命案受害人详情
     *
     * @param homicideVictimId
     * @return
     */
    HomicideVictimDTO get(String homicideVictimId);

    /**
     * 命案受害人详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideVictimBO getBO(Map<String, Object> params);

    /**
     * 命案受害人详情
     *
     * @param homicideVictimId
     * @return
     */
    HomicideVictimBO getBO(String homicideVictimId);

    /**
     * 命案受害人详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideVictimPO getPO(Map<String, Object> params);

    /**
     * 命案受害人详情
     *
     * @param homicideVictimId
     * @return
     */
    HomicideVictimPO getPO(String homicideVictimId);

    /**
     * 命案受害人列表
     *
     * @param params
     * @return
     */
    List<HomicideVictimDTO> list(Map<String, Object> params);

    /**
     * 命案受害人列表
     *
     * @param params
     * @return
     */
    List<HomicideVictimBO> listBO(Map<String, Object> params);

    /**
     * 命案受害人列表
     *
     * @param params
     * @return
     */
    List<HomicideVictimPO> listPO(Map<String, Object> params);

    /**
     * 命案受害人分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<HomicideVictimDTO>> listPage(ListPage page);

    /**
     * 命案受害人统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}